      SUBROUTINE ZF17D(FUNCD,A,B,EPS,ROOT,ITMAX,IERR)
      INTEGER ITMAX,IERR,I,ITER
      DOUBLE PRECISION A,B,EPS,ROOT,FL,FH,DF,XL,XH,SWAP,DXOLD,DX,F,TEMP,
     *ZERO
      COMMON/ZF17RR/ITER
      DATA ZERO/0.0D0/
      IERR=0
      CALL FUNCD(A,FL,DF)
      CALL FUNCD(B,FH,DF)
      IF(FL*FH.LT.ZERO) GO TO 10
      IERR=66
      GO TO 90
   10 IF(FL.GE.ZERO) GO TO 20
      XL=A
      XH=B
      GO TO 30
   20 XH=A
      XL=B
      SWAP=FL
      FL=FH
      FH=SWAP
   30 ROOT=(A+B)/2
      DXOLD=DABS(B-A)
      DX=DXOLD
      CALL FUNCD(ROOT,F,DF)
      DO 70 I=1,ITMAX
      ITER=I
      IF(((ROOT-XH)*DF-F)*((ROOT-XL)*DF-F).GE.ZERO
     1     .OR.DABS(2*F).GT.DABS(DXOLD*DF)) GO TO 40
      DXOLD=DX
      DX=F/DF
      TEMP=ROOT
      ROOT=ROOT-DX
      IF(TEMP.EQ.ROOT) GO TO 80
      GO TO 50
   40 DXOLD=DX
      DX=(XH-XL)/2
      ROOT=XL+DX
      IF(XL.EQ.ROOT) GO TO 80
   50 IF(DABS(DX).LT.DABS(EPS)) GO TO 80
      CALL FUNCD(ROOT,F,DF)
      IF(F.LT.ZERO) GO TO 60
      XH=ROOT
      FH=F
      GO TO 70
   60 XL=ROOT
      FL=F
   70 CONTINUE
      IERR=65
   90 CALL UTZF11(IERR,17)
   80 RETURN
      END
